{

EZ-PGP is copyright 1994, 1995, 1996 by John Schofield.  This source code may
be freely modified and distributed as long as:

		1)  Credit is given to John Schofield
		2)  No money is charged for the program

In other words, feel free to use this, but don't steal it from me, and do NOT
charge money for any product you make using EZ-PGP's source code.


I move frequently, and methods of contacting me don't stay good very long.
However, I'm making an effort to keep two of them good no matter what.

You can always e-mail me at ac086@lafn.org.

You can always write me at:

								John Schofield
								P.O. Box 571312
								Tarzana, CA 91357-1312


}


{
PS:  This code might look kind of screwed if you don't have your tabs set
to 2 spaces, like I do.
}


(*  Exit Codes  *)
(*  3  --  EZ-PGP.CFG is of the wrong version  *)
(*  4  --  EZ-PGP.CFG not found  *)
(*  5  --  File not found  *)
(*  6  --  PGP or File-wiping program not present and user chose to exit. *)

{$M 25000, 0, 0}

Program EZ_PGP;

Uses
	DOS,
	CRT,
	MISC;

Const
	(*  Misc Constants *)
	LastCompatVer = 1.06;  (*  Last version with a compatible config file *)
	Version = '1.07';				(*  Version number ONLY of this version goes here.*)
	VersionXtra = '';				(*  Used for "BETA", etc. after version number. *)
	MiddleLine = 9;				 (*  Line dividing the menu window from the DOS *)
												 (*  window.  The bottom of the menu window is on *)
												 (*  MiddleLine.  *)
	Tag = '**EZ-PGP v' + Version + VersionXtra;

	MaxAddr = 10;  (* Maximum Internet Addresses per message *)

	FileBytes = 2306;			 (* Size of config file in bytes *)
	ConfigFileN = 'EZ-PGP.CFG';  (*  Name of configuration file.  *)

	(*  Temp Files *)
	TTxt = '$$TEMP$$.TXT';
	TAsc = '$$TEMP$$.ASC';

	(*  Left, top, right, and bottom of the DOS window.  *)
	DosWinL = 1;
	DosWinT = MiddleLine + 2;
	DosWinR = 80;
	DosWinB = 24;

	(*  Left, Top, Right, and Bottom of the Menu Window.  *)
	MenuWinL = 5;
	MenuWinT = 1;
	MenuWinR = 76;
	MenuWinB = MiddleLine;


	Mar = 5;  (*  Left margin in text boxes  *)
	TAB = Mar + 3;  (* Tab in text boxes *)

	(* Color Constants *)
	MenuFG = LightGray;   (*  Menu window foreground *)
	MenuBG = Blue;				(*	Menu window background *)
	MenuFrHi = White;			(*	Menu frame foreground high *)
	MenuFrLo = LightGray; (*  Menu frame foreground low *)
	MenuFrBg = Blue;			(*	Menu frame background *)
	MenuLow = Cyan;				(*  For items not available in menu *)
	MenuHigh = White;     (*	For emphasis on menu items *)
	DOSFg = LightGray;    (*  DOS window foreground *)
	DOSBG = Blue;					(*	DOS window background *)
	DOSFrBg = Blue;				(*	DOS frame background *)
	DOSFrHi = White;			(*	DOS frame foreground high *)
	DosFrLo = LightGray;  (*  Dos frame foreground low *)
	ErrorFG = LightGray;	(*  Error window foreground *)
	ErrorBG = Red;				(*	Error window background *)
	ErrorFrFG = White;		(*	Error frame foreground *)
	ErrorFrBG = Red;			(*  Error frame background *)
	ExitFg = LightGray;		(*	Foreground to set before exiting to DOS *)
	ExitBg = Black;				(*	Background to set before exiting to DOS *)

Type
	ConfigType = Record
		Config_Version,
		PGPProg,
		Sign,
		SignAndEncrypt,
		PostKey,
		WipeProgram,
		WipeCommand,
		SpellProgram,
		SpellCommand : String;
		InterFido,
		QuickExit : Boolean;
	End;


Var
	OLD_29H :	Pointer;       (* Pointer to the old Int $29 interrupt *)
	C				:	Char;          (* Holds Charactor to Write *)
	Cursor	: CursorType;    (* Saves the cursor to restore it before exit. *)

{$F+}
Procedure Patch1;	Interrupt;
Begin
    Write(C);
End;

Procedure Patch; Assembler;
	Asm
		Push	DS
		Push	Ax
		Mov		AX, Seg C;
		Mov		DS, AX;
		Pop		AX;
		Mov		C, Al;
		Pop		DS
		Jmp		Patch1;
	End;

{$F-}

(****************************************************************************)

Procedure ExitProg(Code : Word);
Begin
	SetIntVec($29, OLD_29h);
	Window(1, 1, 80, 25);
	TextColor(ExitFg);
	TextBackGround(ExitBg);
	ClrScr;
	RestoreCursor(Cursor);
	Halt(Code);
End;

(****************************************************************************)

Procedure ClearAll;
Begin
	Window(1, 1, 80, 25);
	TextColor(ExitFg);
	TextBackGround(ExitBg);
	ClrScr;
End;

(****************************************************************************)

(*  False if temp files exist  *)
Function TestForTemp : Boolean;
Begin
	If FileExist(Ttxt) Then
		Begin
			TestForTemp := False;
			TextColor(ErrorFrFg);
			TextBackGround(ErrorFrBg);
			MakeBox(15, 3, 65, 22);
			TextColor(ErrorFg);
			TextBackGround(ErrorBg);
			ClrScr;
			WriteCenter(2, 'WARNING');
			WriteAt(Mar, 4, 'EZ-PGP has found a file called');
			WriteAt(Mar, 5, Ttxt + '  EZ-PGP can not continue');
			WriteAt(Mar, 6, 'while this file exists.  Please look at');
			WriteAt(mar, 7, 'this file and rename or delete it.');
			WriteAt(Mar, 8, 'Most likely, this file is left over');
			WriteAt(Mar, 9, 'from the last time EZ-PGP ran.  This');
			WriteAt(Mar, 10, 'could be a serious security breach.  If');
			WriteAt(Mar, 11, 'you have changed the PGP command lines');
			WriteAt(Mar, 12, 'or the wipe program and command lines,');
			WriteAt(mar, 13, 'please check your work.  If you have NOT');
			WriteAt(Mar, 14, 'changed these defaults, please contact the');
			WriteAt(mar, 15, 'author immediately.');
			WriteCenter(17, 'Please hit any key to continue...');
			Repeat Until Keypressed;

			TextColor(ExitFg);
			TextBackGround(ExitBg);
			Window(1, 1, 80, 25);
			ClrScr;

			Window(DosWinL, DosWinT, DosWinR, DosWinB);
			TextColor(DosFg);
			TextBackGround(DosBg);
			ClrScr;

			Window(1, 1, 80, 25);
		End
	Else If FileExist(Tasc) Then
		Begin
			TestForTemp := False;
			TextColor(ErrorFrFg);
			TextBackGround(ErrorFrBg);
			MakeBox(15, 3, 65, 22);
			TextColor(ErrorFg);
			TextBackGround(ErrorBg);
			ClrScr;
			WriteCenter(2, 'WARNING');
			WriteAt(Mar, 4, 'EZ-PGP has found a file called');
			WriteAt(Mar, 5, Tasc + '  EZ-PGP can not continue');
			WriteAt(Mar, 6, 'while this file exists.  Please look at');
			WriteAt(mar, 7, 'this file and rename or delete it.');
			WriteAt(Mar, 8, 'Most likely, this file is left over');
			WriteAt(Mar, 9, 'from the last time EZ-PGP ran.  This');
			WriteAt(Mar, 10, 'could be a serious security breach.  If');
			WriteAt(Mar, 11, 'you have changed the PGP command lines');
			WriteAt(Mar, 12, 'or the wipe program and command lines,');
			WriteAt(mar, 13, 'please check your work.  If you have NOT');
			WriteAt(Mar, 14, 'changed these defaults, please contact the');
			WriteAt(mar, 15, 'author immediately.');
			WriteCenter(17, 'Please hit any key to continue...');
			Repeat Until Keypressed;

			TextColor(ExitFg);
			TextBackGround(ExitBg);
			Window(1, 1, 80, 25);
			ClrScr;

			Window(DosWinL, DosWinT, DosWinR, DosWinB);
			TextColor(DosFg);
			TextBackGround(DosBg);
			ClrScr;

			Window(1, 1, 80, 25);
		End;
End;

(****************************************************************************)

Procedure ShowHelp;
Begin
	Window(1,1, 80, 25);
	TextbackGround(Black);
	ClrScr;
	TextColor(MenuFrHi);
	TextBackGround(MenuFrBG);
	MakeBox(1, 1, 30, 5);
	TextColor(MenuFg);
	TextBackGround(MenuBg);
	ClrScr;

	WriteCenter(1, 'EZ-PGP');
	WriteCenter(2, 'Version ' + Version + VersionXtra);
	WriteCenter(3, 'by John Schofield');

	TextColor(MenuFrHi);
	TextBackGround(MenuFrBg);
	MakeBox(5, 7, 75, 22);
	TextColor(MenuFg);
	TextBackGround(MenuBg);
	ClrScr;
	WriteAt(Mar, 2, 'EZ-PGP has three modes:');
	WriteAt(Mar, 4, 'C:\> EZ-PGP E <FILENAME>');
	WriteAt(Mar + 5, 5, 'Run this after writing a message.');
	WriteAt(Mar, 7, 'C:\> EZ-PGP C');
	WriteAt(Mar + 5, 8, 'Run this to configure EZ-PGP');
	WriteAt(Mar, 10, 'C:\> EZ-PGP ?');
	WriteAt(Mar + 5, 11, 'Run this to see this screen.');
	WriteCenter(13, 'Please press a key to continue...');
	Repeat Until Keypressed;
	TextColor(ExitFg);
	TextBackGround(ExitBg);
	Window(1, 1, 80, 25);
	ClrScr;
End;

(****************************************************************************)

Procedure ReadConfigFile(Var C : ConfigType; Var ConfigPath : String);
Var
	PGPPath : String;
	F : File of ConfigType;
	Ch : Char;
	Left,
	Right : Integer;

	(*  Used to store values for old and new configuration numbers.  *)
	OldVer : Real;
	Code : Integer;

	(*  Reset the configfile with this variable to get the file size *)
	TempF : File;

(*--------------------------------------------------------------------------*)

	Procedure PathError;
	Begin   (* PathError *)
		ClrScr;
		TextColor(ErrorFrFg);
		TextBackGround(ErrorFrBg);
		MakeBox(6, 5, 74, 16);
		TextColor(ErrorFg);
		TextBackGround(ErrorBg);
		ClrScr;
		WriteCenter(1, 'WARNING');
		WriteAt(Mar, 3, 'You do not have the PGPPATH environment variable set.');
		WriteAt(Mar, 4, 'EZ-PGP will not work without PGPPATH.  Please read the');
		WriteAt(Mar, 5, 'PGP documentation for more information.  In PGP version');
		WriteAt(Mar, 6, '2.3a, information on PGPPATH is located in PGPDOC1.TXT.');
		WriteCenter(7, 'Press any key to continue...');
		Repeat Until Keypressed;
		ExitProg(1);
	End;   (* PathError *)

(*--------------------------------------------------------------------------*)

	Procedure WriteConfig(FileN : String; Var C : ConfigType);
	Var
		F : File of ConfigType;
	Begin
		Assign(F, FileN);
		ReWrite(F);
		FillChar(C, SizeOf(C), 0);
		C.Config_Version	:= Version;
		C.PGPProg         := PGPPath + 'PGP.EXE';
		C.Sign						:= '-sta +clearsig=on @F';
		C.SignAndEncrypt	:= '-sea @F @L';
		C.PostKey					:= '-kxa "@N"';
		C.WipeProgram			:= PGPPath + 'PGP.EXE';
		C.WipeCommand     := '-w @F';
		C.SpellCommand		:= '';
		C.SpellProgram    := '';
		C.QuickExit				:= False;
		C.InterFido				:= False;
		Write(F, C);
		Close(F);
	End;

(*--------------------------------------------------------------------------*)

	Procedure OldConfig(FileN : String; Var C : ConfigType);
	Var
		Ch : Char;
		F : File;
	Begin
		ClrScr;
		TextColor(ErrorFrFg);
		TextBackGround(ErrorFrBg);
		MakeBox(6, 5, 74, 16);
		TextColor(ErrorFg);
		TextBackGround(ErrorBg);
		ClrScr;
		WriteCenter(1, 'WARNING');
		WriteAt(Mar, 3, 'EZ-PGP has found a copy of ' + ConfigFileN + ' that is from an old');
		WriteAt(Mar, 4, 'version of EZ-PGP.  Since there is no conversion program, the');
		WriteAt(Mar, 5, 'file will have to be deleted from the PGP directory so');
		WriteAt(Mar, 6, 'EZ-PGP can create a new configuration file.  You will have to');
		WriteAt(Mar, 7, 're-enter any changes you made to the EZ-PGP configuration.');
		WriteAt(Mar, 9, 'Press "Y" to delete '+ ConfigFileN + ' and create a new config');
		WriteAt(Mar, 10, 'file, or any other key to exit.');
		Ch := UpCase(ReadKey);
		If Ch = 'Y' Then
			Begin
				Assign(F, FileN);
				Erase(F);
				WriteConfig(FileN, C);

				Window(1, 1, 80, 25);
				TextColor(ExitFg);
				TextBackGround(ExitBg);
				ClrScr;
				Window(DosWinL, DosWinT, DosWinR, DosWinB);
				TextColor(DosFg);
				TextBackGround(DosBg);
				ClrScr;
			End
		Else
			ExitProg(5);
	End;

(*--------------------------------------------------------------------------*)

Begin  (*  ReadConfigFile *)
	PGPPath := GetEnv('PGPPATH');
	If PGPPath = '' Then
		PathError
	Else
		Begin
			If PGPPath[Length(PGPPath)] <> '\' Then
				PGPPath := PGPPath + '\';
			ConfigPath := PGPPath + ConfigFileN;
			If FileExist(ConfigPath) Then
				Begin
					Assign(TempF, ConfigPath);
					Reset(TempF, 1);
					If FileSize(TempF) <> FileBytes Then
						OldConfig(ConfigPath, C)
					Else
						Begin
							Close(TempF);
							Assign(F, ConfigPath);
							Reset(F);
							Read(F, C);
							Close(F);
							Val(C.Config_Version, OldVer, Code);
							If Code <> 0 Then
								OldConfig(ConfigPath, C);
							If OldVer < LastCompatVer Then
								OldConfig(ConfigPath, C);
						End;
				End
			Else
				Begin  (*  Write Configs *)
					TextColor(ExitFg);
					TextBackGround(ExitBg);
					Window(1, 1, 80, 25);
					ClrScr;

					TextColor(ErrorFrFg);
					TextBackGround(ErrorFrBg);

					(*  Center box on screen with room for PGPPath  *)
					Left := 80 - (Length(ConfigPath) + 34);
					Left := Round(Left / 2);
					Right := Left + Length(ConfigPath) + 34;
					If Length(ConfigPath) <= 15 Then
						Begin
							Left := 15;
							Right := 65;
						End;

					MakeBox(Left, 5, Right, 14);
					TextColor(ErrorFg);
					TextBackground(ErrorBg);
					ClrScr;

					WriteCenter(1, 'WARNING');
					WriteAt(Mar, 3, 'EZ-PGP could not find ' + ConfigPath + '.');
					WriteAt(Mar, 4, 'If you want EZ-PGP to create ' + ConfigFileN);
					WriteAt(Mar, 5, 'with default values, press "Y".  If you');
					WriteAt(Mar, 6, 'want to try to find your missing copy of');
					WriteAt(Mar, 7, ConfigFileN + ', press any other key.');
					SmallCursor;
					Ch := UpCase(ReadKey);
					NoCursor;
					TextColor(ExitFg);
					TextBackGround(ExitBg);
					Window(1, 1, 80, 25);
					ClrScr;

					If Ch = 'Y' Then
						Begin
							Window(1, 1, 80, 25);
							ClrScr;

							Window(DosWinL, DosWinT, DosWinR, DosWinB);
							TextColor(DosFg);
							TextBackGround(DosBg);
							ClrScr;
							WriteConfig(ConfigPath, C);
						End
					Else
						ExitProg(4);
				End;   (*  Write Configs  *)
		End;
End;   (*  ReadConfigFile  *)


(****************************************************************************)


Procedure RunConfig(Var Config : ConfigType; ConfigPath : String);
Var
	Ch1,
	Ch		: Char;
	F			: File of ConfigType;
	Temp	: String;

(*--------------------------------------------------------------------------*)

	Procedure DetailedConfig(Var C : Configtype);
	Var
		Ch : Char;
		Temp : String;
	Begin
		Repeat
			TextColor(ExitFg);
			TextBackGround(ExitBg);
			Window(1, 1, 80, 25);
			ClrScr;

			TextColor(MenuFrHi);
			TextBackGround(MenuFrBg);
			MakeBox(7, 4, 73, 20);
			TextColor(MenuFg);
			TextBackGround(MenuBg);
			ClrScr;

			WriteCenter(2, 'Advanced Configuration');
			WriteAt(Mar, 4, 'A -- Path and file name of PGP program');
			WriteAt(Mar, 5, 'B ------ Command-line to sign a message');
			WriteAt(Mar, 6, 'C ------ Command-line to sign and encrypt a message');
			WriteAt(Mar, 7, 'D ------ Command-line to post a key');
			WriteAt(Mar, 8, 'E -- Path and file name of file-wiping program');
			WrIteAt(Mar, 9, 'F ------ Command-line to wipe a file');
			WriteAt(Mar, 11, 'Hit [ENTER] to exit.');
			WriteAt(Mar, 13, 'Your choice:  ');
			SmallCursor;
			Ch := UpCase(ReadKey);
			Write(Ch);
			Case Ch Of

				'A' : Begin
								TextColor(DosFrHi);
								TextBackGround(DosFrBg);
								MakeBox(7, 9, 73, 15);
								TextColor(DosFg);
								TextBackGround(DosBg);
								ClrScr;
								WriteAt(Mar, 1, 'Enter the path and file name of your PGP program.');
								WriteAt(Mar, 2, 'Currently:  "' + Config.PGPProg + '"');
								WriteAt(Mar, 3, '(Hit [ENTER] for no change or ~ to blank it.)');
								WriteAt(Mar, 5, '>  ');
								ReadLn(Temp);
								If Temp = '~' Then
									FillChar(Config.PGPProg, SizeOf(Config.PGPProg), 0)
								Else If Temp <> '' Then
									Config.PGPProg := Temp
							End;

				'B' :	Begin
								TextColor(DosFrHi);
								TextBackGround(DosFrBg);
								MakeBox(7, 8, 73, 15);
								TextColor(DosFg);
								TextBackGround(DosBg);
								ClrScr;
								WriteAt(Mar, 1, 'Enter the command-line to sign a message.');
								WriteAt(Mar, 2, 'Currently:  "' + Config.Sign + '"');
								WriteAt(Mar, 3, '(Hit [ENTER] for no change or ~ to blank it.)');
								WriteAt(Mar, 4, '(Use @F to pass the file name.)');
								WriteAt(Mar, 6, '>  ');
								ReadLn(Temp);
								If Temp = '~' Then
									FillChar(Config.Sign, SizeOf(Config.Sign), 0)
								Else If Temp <> '' Then
									Config.Sign := Temp
							End;

				'C'	: Begin
								TextColor(DosFrHi);
								TextBackGround(DosFrBg);
								MakeBox(7, 8, 73, 15);
								TextColor(DosFg);
								TextBackGround(DosBg);
								ClrScr;
								WriteAt(Mar, 1, 'Enter the command-line to sign and encrypt a message.');
								WriteAt(Mar, 2, 'Currently:  "' + Config.SignAndEncrypt + '"');
								WriteAt(Mar, 3, '(Hit [ENTER] for no change or ~ to blank it.)');
								WriteAt(Mar, 4, '(Use @F to pass the file name, @L to pass the list of names.)');
								WriteAt(Mar, 6, '>  ');
								ReadLn(Temp);
								If Temp = '~' Then
									FillChar(Config.SignAndEncrypt, SizeOf(Config.SignAndEncrypt), 0)
								Else If Temp <> '' Then
									Config.SignAndEncrypt := Temp
							End;


				'D' : Begin
								TextColor(DosFrHi);
								TextBackGround(DosFrBg);
								MakeBox(7, 8, 73, 15);
								TextColor(DosFg);
								TextBackGround(DosBg);
								ClrScr;
								WriteAt(Mar, 1, 'Enter the command-line to post a key in a message.');
								WriteAt(Mar, 2, 'Currently:  "' + Config.PostKey + '"');
								WriteAt(Mar, 3, '(Hit [ENTER] for no change or ~ to blank it.)');
								WriteAt(Mar, 4, '(Use @N to pass the Key ID you want to post.)');
								WriteAt(Mar, 6, '>  ');
								ReadLn(Temp);
								If Temp = '~' Then
									FillChar(Config.PostKey, SizeOf(Config.PostKey), 0)
								Else If Temp <> '' Then
									Config.PostKey := Temp
							End;

				'E'	:	Begin
								TextColor(DosFrHi);
								TextBackGround(DosFrBg);
								MakeBox(7, 9, 73, 15);
								TextColor(DosFg);
								TextBackGround(DosBg);
								ClrScr;
								WriteAt(Mar, 1, 'Enter the path and file name of your file wiping program.');
								WriteAt(Mar, 2, 'Currently:  "' + Config.WipeProgram + '"');
								WriteAt(Mar, 3, '(Hit [ENTER] for no change or ~ to blank it.)');
								WriteAt(Mar, 5, '>  ');
								ReadLn(Temp);
								If Temp = '~' Then
									FillChar(Config.WipeProgram, SizeOf(Config.WipeProgram), 0)
								Else If Temp <> '' Then
									Config.WipeProgram := Temp
							End;

				'F' : Begin
								TextColor(DosFrHi);
								TextBackGround(DosFrBg);
								MakeBox(7, 8, 73, 15);
								TextColor(DosFg);
								TextBackGround(DosBg);
								ClrScr;
								WriteAt(Mar, 1, 'Enter the command-line to wipe a file.');
								WriteAt(Mar, 2, 'Currently:  "' + Config.WipeCommand + '"');
								WriteAt(Mar, 3, '(Hit [ENTER] for no change or ~ to blank it.)');
								WriteAt(Mar, 4, '(Use @F to pass the file name.)');
								WriteAt(Mar, 6, '>  ');
								ReadLn(Temp);
								If Temp = '~' Then
									FillChar(Config.WipeCommand, SizeOf(Config.WipeCommand), 0)
								Else If Temp <> '' Then
									Config.WipeCommand := Temp
							End;

			End;  (*  Case  *)
		Until Ch = #13;
		NoCursor;
	End;

(*--------------------------------------------------------------------------*)

Begin
	Repeat
		TextColor(ExitFg);
		TextBackGround(ExitBg);
		Window(1, 1, 80, 25);
		ClrScr;
		TextColor(MenuFrHi);
		TextBackGround(MenuFrBg);
		MakeBox(13, 4, 67, 18);
		TextColor(MenuFg);
		TextBackGround(MenuBg);
		ClrScr;
		WriteCenter(2, 'EZ-PGP Configuration');
		WriteAt(Mar, 4, 'A -- Path and file name of spell-check program');
		WriteAt(Mar, 5, 'B -- Command-line to spell-check a message');
		WriteAt(Mar, 6, 'C -- Exit EZ-PGP after one operation');
		WriteAt(Mar, 7, 'D -- Fidonet --> Internet addressing');
		WriteAt(Mar, 8, 'E -- Advanced configuration');
		WriteAt(Mar, 10, 'Hit [ENTER] to exit.');
		WriteAt(Mar, 12, 'Your choice:  ');
		SmallCursor;
		Ch := UpCase(ReadKey);
		Write(Ch);
		Case Ch Of

			'A' : Begin
							TextColor(DosFrHi);
							TextBackGround(DosFrBg);
							MakeBox(7, 9, 73, 15);
							TextColor(DosFg);
							TextBackGround(DosBg);
							ClrScr;
							WriteAt(Mar, 1, 'Enter the path and file name of your spell-check program.');
							WriteAt(Mar, 2, 'Currently:  "' + Config.SpellProgram + '"');
							WriteAt(Mar, 3, '(Hit [ENTER] for no change or ~ to blank it.)');
							WriteAt(Mar, 5, '>  ');
							ReadLn(Temp);
							If Temp = '~' Then
								FillChar(Config.SpellProgram, SizeOf(Config.SpellProgram), 0)
							Else If Temp <> '' Then
								Config.SpellProgram := Temp
						End;

			'B'	:	Begin
							TextColor(DosFrHi);
							TextBackGround(DosFrBg);
							MakeBox(12, 8, 68, 15);
							TextColor(DosFg);
							TextBackGround(DosBg);
							ClrScr;
							WriteAt(Mar, 1, 'Enter the command-line to spell-check a message.');
							WriteAt(Mar, 2, 'Currently:  "' + Config.SpellCommand + '"');
							WriteAt(Mar, 3, '(Hit [ENTER] for no change or ~ to blank it.)');
							WriteAt(Mar, 4, '(Use @F to pass the file name.)');
							WriteAt(Mar, 6, '>  ');
							ReadLn(Temp);
							If Temp = '~' Then
								FillChar(Config.SpellCommand, SizeOf(Config.SpellCommand), 0)
							Else If Temp <> '' Then
								Config.SpellCommand := Temp
						End;

			'C'	:	Begin
							TextColor(DosFrHi);
							TextBackGround(DosFrBg);
							MakeBox(10, 8, 70, 15);
							TextColor(DosFg);
							TextBackGround(DosBg);
							ClrScr;
							WriteAt(Mar, 1, 'Should EZ-PGP quick-exit after doing one function?');
							If Config.QuickExit = True Then
								WriteAt(Mar, 3, 'Currently:  Yes')
							Else
								WriteAt(Mar, 3, 'Currently:  No');
							WriteAt(Mar, 4, '(Hit [ENTER] for no change, Y for yes and N for no.)');
							WriteAt(Mar, 6, '>  ');
							Repeat
								Ch1 := UpCase(ReadKey);
							Until Ch1 In [#13, 'Y', 'N'];

							If Ch1 = 'Y' Then
								Config.QuickExit := True
							Else If Ch1 = 'N' Then
								Config.QuickExit := False;
						End;

			'D'	:	Begin
							TextColor(DosFrHi);
							TextBackGround(DosFrBg);
							MakeBox(10, 8, 70, 15);
							TextColor(DosFg);
							TextBackGround(DosBg);
							ClrScr;
							WriteAt(Mar, 1, 'Should EZ-PGP do Fidonet to Internet addressing?');
							If Config.InterFido = True Then
								WriteAt(Mar, 3, 'Currently:  Yes')
							Else
								WriteAt(Mar, 3, 'Currently:  No');
							WriteAt(Mar, 4, '(Hit [ENTER] for no change, Y for yes and N for no.)');
							WriteAt(Mar, 6, '>  ');
							Repeat
								Ch1 := UpCase(ReadKey);
							Until Ch1 In [#13, 'Y', 'N'];

							If Ch1 = 'Y' Then
								Config.Interfido := True
							Else If Ch1 = 'N' Then
								Config.Interfido := False;
						End;

			'E' : DetailedConfig(Config);

		End;  (*  Case  *)
	Until Ch = #13;
	Assign(F, ConfigPath);
	ReWrite(F);
	Write(F, Config);
	Close(F);
	Window(1, 1, 80, 25);
	TextColor(ExitFg);
	TextBackGround(ExitBg);
	ClrScr;
	Window(DosWinL, DosWinT, DosWinR, DosWinB);
	TextColor(DosFg);
	TextBackGround(DosBg);
	ClrScr;
	NoCursor;
End;

(****************************************************************************)

Procedure MakeScreen(C : ConfigType);
Var
	N : Integer;

Begin  (*  MakeScreen *)
	TextColor(DosFrLo);
	TextBackGround(DosFrBg);
	MakeBox(DosWinL, DosWinT, DosWinR, DosWinB);

	TextColor(MenuFrHi);
	TextBackGround(MenuFrBg);
	MakeBox(MenuWinL, MenuWinT, MenuWinR, MenuWinB);  (*  Menu Box  *)
	TextColor(MenuFg);
	TextBackGround(MenuBg);
	ClrScr;


	WriteCenter(1, 'EZ-PGP Version '+ Version + VersionXtra);
	WriteCenter(2, 'by John Schofield');

	If C.Sign = '' Then
		TextColor(MenuLow)
	Else
		TextColor(MenuFg);
	WriteAt(5, 4, 'S  --  Sign Message');

	If C.SignAndEncrypt = '' Then
		TextColor(MenuLow)
	Else
		TextColor(MenuFg);
	WriteAt(5, 5, 'E  --  Sign and Encrypt Message');

	If C.PostKey = '' Then
		TextColor(MenuLow)
	Else
		TextColor(MenuFg);
	WriteAt(5, 6, 'P  --  Post a Key');

	If C.SpellProgram = '' Then
		TextColor(MenuLow)
	Else
		TextColor(MenuFg);
	WriteAt(40, 4, 'C  --  Spell Check Message');

	TextColor(MenuFg);
	WriteAt(40, 5, 'D  --  Change EZ-PGP Defaults');
	WriteAt(40, 6, 'Q  --  Quit EZ-PGP');
End;   (*  MakeScreen  *)

(****************************************************************************)

Procedure NoFile(S : String);
Begin
	If S = '' Then
		Begin
			TextColor(ErrorFrFg);
			TextBackGround(ErrorFrBg);
			MakeBox(13, 5, 67, 16);
			TextColor(ErrorFg);
			TextBackGround(ErrorBg);
			ClrScr;

			WriteCenter(1, 'WARNING');
			WriteAt(Mar, 3, 'EZ-PGP did not receive the name of a file on');
			WriteAt(Mar, 4, 'the command-line.  It is very likely that');
			WriteAt(Mar, 5, 'your off-line mail-reader is configured');
			WriteAt(Mar, 6, 'incorrectly.  Please refer to your mail-reader');
			WriteAt(Mar, 7, 'manual for more information.');
			WriteCenter(9, 'Press any key to continue...');
			Repeat Until Keypressed;
 			Window(1, 1, 80, 25);
			TextColor(ExitFg);
			TextBackGround(ExitBg);
			ClrScr;
		End
	Else
		Begin
			TextColor(ErrorFrFg);
			TextBackGround(ErrorFrBg);
			MakeBox(15, 7, 65, 17);
			TextColor(ErrorFg);
			TextBackGround(ErrorBg);
			ClrScr;

			WriteCenter(1, 'WARNING');
			GoToXY(1, 3);
			WriteLn('EZ-PGP could not find the file "' + S + '".');
			WriteLn('Perhaps your off-line reader is not configured');
			WriteLn('correctly.');
			WriteCenter(8, 'Press any key to continue...');
			Repeat Until Keypressed;
 			Window(1, 1, 80, 25);
			TextColor(ExitFg);
			TextBackGround(ExitBg);
			ClrScr;
		End;

	ExitProg(5);
End;

(****************************************************************************)

Procedure DosTrouble(Error : Integer);
Var
	St : String[40];
Begin
	Window(1, 1, 80, 25);
	TextColor(ErrorFrFg);
	TextBackGround(ErrorFrBg);
	MakeBox(20, 5, 60, 15);
	TextColor(ErrorFg);
	TextBackGround(ErrorBg);
	ClrScr;

	WriteCenter(2, 'WARNING');
	WriteCenter(4, 'DOS Error Received');
	St := 'The error was:  ';
		Case Error of
			2		: St := St + 'File Not Found';
			3		: St := St + 'Path Not Found';
			5		: St := St + 'File Access Denied';
			6		: St := St + 'Invalid File Handle';
			8		: St := St + 'Not Enough Memory';
			10	: St := St + 'Invalid Environment';
			11	: St := St + 'Invalid Format';
			18	: St := St + 'No More Files';
		End;
	WriteCenter(6, St);
	WriteCenter(8, '  Please press any key to continue...');
	Repeat Until Keypressed;
 	TextColor(ExitFg);
	TextBackGround(ExitBg);
	Window(1, 1, 80, 25);
	ClrScr;
End;

(****************************************************************************)

Procedure PGPError;
Begin
	TextColor(ErrorFrFg);
	TextBackGround(ErrorFrBg);
	MakeBox(MenuWinL, MenuWinT, MenuWinR, MenuWinB);
	TextColor(ErrorFg);
	TextBackGround(ErrorBg);
	ClrScr;

	Writeln;
	Writeln;
	Writeln;
	Writeln('There has been some kind of error with PGP.  If you have adjusted');
	Writeln('the default PGP command-line parameters, perhaps you should delete');
	Writeln(ConfigFileN + ' from the PGP directory so that EZ-PGP will re-create the');
	Writeln('default configuration file.');
	Writeln;
	Write('Press a key to continue...');
	Repeat Until Keypressed;
	Window(1, 1, 80, 25);
	TextColor(ExitFg);
	TextBackGround(ExitBg);
	ClrScr;

	Window(DosWinL, DosWinT, DosWinR, DosWinB);
	TextColor(DosFg);
	TextBackGround(DosBg);
	ClrScr;

End;

(****************************************************************************)

Procedure WipeFile(F : String; C : ConfigType);
Var
	ComStr : String;
	N : Integer;
Begin
	ComStr := UpCaseStr(C.WipeCommand);
	N := Pos('@F', ComStr);
	If N > 0 Then
		Begin
			Delete(ComStr, N, 2);
			Insert(F, ComStr, N);
		End;
	SmallCursor;
	SwapVectors;
	Exec(C.WipeProgram, ComStr);
	SwapVectors;
	NoCursor;
	If DosError <> 0 Then
		Begin
			DosTrouble(DosError);
			TextColor(ErrorFrFg);
			TextBackGround(ErrorFrBg);
			MakeBox(10, 4, 70, 21);
			TextColor(ErrorFg);
			TextBackGround(ErrorBg);
			ClrScr;

			WriteCenter(1, 'WARNING');
			GoToXY(1, 3);
			Writeln('EZ-PGP was unable to wipe the file ' + F + '.');
			Writeln('This file may contain cleartext, and may still');
			Writeln('be on your disk.  This could be a breach of');
			Writeln('security.  Please erase this file as soon as');
			Writeln('possible.');
			Writeln;
			Writeln('This may be because you have changed the wipe');
			Writeln('program or command-line.  If you have, you might');
			Writeln('try deleting the file ' + ConfigFileN + ' so that EZ-PGP');
			Writeln('will create a new default CFG file.');
			Writeln;
			WriteCenter(WhereY, 'Please press any key to continue...');
			Repeat Until Keypressed;
			TextColor(ExitFg);
			TextBackGround(ExitBg);
		End;
End;

(****************************************************************************)

(* True if everything is OK *)
Function ProgramTest(Config : ConfigType; PGPPath : String) : Boolean;
Var
	Temp : Boolean;
	Ch : Char;
Begin
	Temp := True;
	If Not FileExist(Config.PGPProg) Then
		Begin
			Temp := False;
			TextColor(ErrorFrFg);
			TextBackGround(ErrorFrBg);
			MakeBox(10, 4, 70, 21);
			TextColor(ErrorFg);
			TextBackGround(ErrorBg);
			ClrScr;
			WriteCenter(2, 'WARNING');
			WriteAt(Mar, 4, 'EZ-PGP was unable to find your PGP');
			WriteAt(Mar, 5, 'program.');
			WriteAt(Mar, 6, 'Press E to exit EZ-PGP or C to');
			WriteAt(Mar, 7, 'change your default settings.');
			Repeat
				Ch := UpCase(ReadKey);
			Until Ch In ['E', 'C'];
			If Ch = 'E' Then
				ExitProg(6)
			Else
				Begin
					RunConfig(Config, PGPPath);
					Window(1, 1, 80, 25);
					TextColor(ExitFg);
					TextBackGround(ExitBg);
					ClrScr;
				End;
		End;
	If Not FileExist(Config.WipeProgram) Then
		Begin
			Temp := False;
			TextColor(ErrorFrFg);
			TextBackGround(ErrorFrBg);
			MakeBox(10, 4, 70, 21);
			TextColor(ErrorFg);
			TextBackGround(ErrorBg);
			ClrScr;
			WriteCenter(2, 'WARNING');
			WriteAt(Mar, 4, 'EZ-PGP was unable to find your file-');
			WriteAt(Mar, 5, 'wiping program.');
			WriteAt(Mar, 6, 'Press E to exit EZ-PGP or C to');
			WriteAt(Mar, 7, 'change your default settings.');
			Repeat
				Ch := UpCase(ReadKey);
			Until Ch In ['E', 'C'];
			If Ch = 'E' Then
				ExitProg(6)
			Else
				Begin
					RunConfig(Config, PGPPath);
					Window(1, 1, 80, 25);
					TextColor(ExitFg);
					TextBackGround(ExitBg);
					ClrScr;
				End;
		End;
	ProgramTest := Temp;
End;

(****************************************************************************)

Procedure SignMessage(		Config	: ConfigType;
											Var ExitNow	: Boolean;
													FileN		: String);
Var
	N : Byte;
	F : File;
	FDest,
	FSource : text;
	ComStr,
	List,
	LineTemp : String;
	AddrCount : Byte;
	InterAddr : Array[1..MaxAddr] Of String;

Begin
	If (Config.Sign <> '') And TestForTemp Then
		Begin
			FillChar(InterAddr, SizeOf(InterAddr), 0);
			AddrCount := 0;

			If Config.QuickExit Then
				ExitNow := True;

			TextColor(MenuHigh);
			WriteCenter(7, 'Signing a Message');

			(* Dim out menu box *)
			TextColor(MenuFrLo);
			TextBackGround(MenuFrBg);
			MakeBox(MenuWinL, MenuWinT, MenuWinR, MenuWinB);

			(* Make DOS box *)
			TextColor(DOSFrHi);
			TextBackGround(DOSFrBg);
			MakeBox(DosWinL, DosWinT, DosWinR, DosWinB);
			TextColor(DOSFg);
			TextBackGround(DOSBg);
			ClrScr;

			(* Note:  This code does not check if the only text in a file is *)
			(* Internet addresses, with no actual text.                      *)

			If Config.InterFido = True Then
				Begin  (*  Search for internet address *)
					Assign(FSource, FileN);
					Reset(FSource);
					Readln(FSource, LineTemp);
					If Pos('To: ', LineTemp) = 1 Then
						Begin (* There are Internet Addresses *)
							Close(FSource);          (* We need to close fsource to work *)
							Rename(FSource, TTxt);   (* around apparent bug in TP.       *)
							Reset(FSource);

							Assign(FDest, FileN);
							ReWrite(FDest);

							Readln(FSource, LineTemp);

							While (Pos('To: ', LineTemp) = 1) And (AddrCount < MaxAddr) Do
								Begin  (* Copy Internet addresses *)
									Inc(Addrcount);
									InterAddr[AddrCount] := LineTemp;
									Readln(FSource, LineTemp);
								End;   (* Copy Internet addresses *)

							Writeln(FDest, LineTemp);

							While Not EOF(FSource) Do
								Begin  (* Copy the rest of the file *)
									ReadLn(FSource, LineTemp);
									Writeln(FDest, LineTemp);
								End;
							Close(FDest);
							Close(FSource);
							WipeFile(TTxt, Config);
						End;  (* There are Internet Addresses *)
				End;  (* Search for Internet Addresses *)

			Assign(F, FileN);
			ReName(F, TTXT);

			ComStr := UpCaseStr(Config.Sign);
			N := Pos('@F', ComStr);
			If N > 0 Then
				Begin
					Delete(ComStr, N, 2);
					Insert(Ttxt, ComStr, N);
				End;

			SmallCursor;
			Swapvectors;
			Exec(Config.PGPProg, ComStr);
			Swapvectors;
			NoCursor;

			If DosError <> 0 Then
				Begin
					DosTrouble(DosError);
					ReName(F, FileN);
				End
			Else If FileExist(Tasc) Then
				Begin
					Assign(F, Tasc);
					Rename(F, FileN);
					WipeFile(Ttxt, Config);
				End
			Else
				Begin
					ReName(F, FileN);
					PGPError;
				End;

			If AddrCount > 0 Then
				Begin  (* Need to add Internet Addresses *)
					Assign(FSource, FileN);
					Rename(FSource, Ttxt);
					Reset(FSource);
					Assign(FDest, FileN);
					ReWrite(FDest);

					For N := 1 to AddrCount Do
						Writeln(FDest, InterAddr[N]);

					Writeln(FDest);
					Writeln(FDest);

					While not EOF(FSource) Do
						Begin
							Readln(FSource, LineTemp);
							Writeln(FDest, LineTemp);
						End;

          Writeln(FDest, Tag);

					Close(FDest);
					Close(FSource);
					Wipefile(Ttxt, Config);
				End  (* Need to add internet Addresses *)
			Else
				Begin (* Need to add tag *)
					Assign(FSource, FileN);
					ReName(Fsource, Ttxt);
					Reset(FSource);
					Assign(FDest, FileN);
					ReWrite(FDest);
					While Not EOF(FSource) Do
						Begin
							Readln(FSource, LineTemp);
							Writeln(FDest, LineTemp);
						End;
					Writeln(FDest, Tag);
					Close(FSource);
					Close(FDest);
					WipeFile(Ttxt, config);
				End;  (* Need to add tag *)

		End;
End;   (*  Sign  *)

(****************************************************************************)

Procedure SignAndEncryptMessage(		Config : ConfigType;
																Var ExitNow : Boolean;
																		FileN : String);
Var
	N : Byte;
	F : File;

	FSource,
	FDest : Text;

	ComStr,
	List,
	ListTemp,
	LineTemp : String;

	InterAddr : Array[1..MaxAddr] of String;
	AddrCount : Byte;

Begin  (*  Sign and Encrypt *)
	If (Config.SignAndEncrypt <> '') And TestForTemp Then
		Begin
			If Config.QuickExit Then
				ExitNow := True;

			AddrCount := 0;
			FillChar(InterAddr, SizeOf(InterAddr), 0);

			(*  Write Help file in DOS Window Space *)
			TextColor(DosFrLo);
			TextBackground(DosFrBg);
			MakeBox(DosWinL, DosWinT, DosWinR, DosWinB);
			TextColor(DOSFg);
			TextBackGround(DOSBG);
			WriteCenter(1, 'Signing and Encrypting');
			WriteAt(Mar, 3, 'Enter each person you are encrypting the message to on one line.  If you');
			WriteAt(Mar, 4, 'are just encrypting to one person, simply enter that person''s key ID and');
			WriteAt(Mar, 5, 'hit ENTER on the next line.');
			WriteAt(Mar, 7, 'To encrypt to more than one person, simply enter more key IDs, one on');
			WriteAt(Mar, 8, 'each line.  Hit ENTER alone on a line to exit.');
			WriteAt(Mar, 10, 'If the key ID you want to enter has a space in it, you must surround it ');
			WriteAt(Mar, 11, 'with quote marks.  For example:');
			WriteAt(Tab, 12, '"Schofield, John"');

			(*  Get list of ID's *)
			FillChar(List, SizeOf(List), 0);
			TextColor(MenuFrHi);
			TextBackGround(MenuFrBg);
			MakeBox(MenuWinL, MenuWinT, MenuWinR, MenuWinB);
			TextColor(MenuFg);
			TextBackGround(MenuBg);
			ClrScr;
			WriteCenter(1, 'To whom do you want to send this message?');
			Writeln;
			Repeat
				ClrEOL;
				Write('User ID (ENTER when done) :  ');
				SmallCursor;
				ClrEOL;
				ReadLn(ListTemp);
				NoCursor;
				If ListTemp <> '' Then
					Begin
						If Length(ListTemp) + 1 < 255 - Length(List) Then
							List := List + ListTemp + ' '
						Else
							Writeln('I am sorry, but that would be too many letters.');
					End;
			Until (List <> '') And (ListTemp = '');

			ClrScr;
			Writeln('Sending a message to:');
			Writeln(List);

			FillChar(InterAddr, SizeOf(InterAddr), 0);

			TextColor(DOSFrHi);
			TextBackGround(DOSFrBg);
			MakeBox(DosWinL, DosWinT, DosWinR, DosWinB);
			TextColor(DOSFg);
			TextBackGround(DOSBg);
			ClrScr;

			(* Note:  This code does not check if the only text in a file is *)
			(* Internet addresses, with no actual text.                      *)

			If Config.InterFido = True Then
				Begin  (*  Search for internet address *)
					Assign(FSource, FileN);
					Reset(FSource);
					Readln(FSource, LineTemp);
					If Pos('To: ', LineTemp) = 1 Then
						Begin (* There are Internet Addresses *)
							Close(FSource);          (* We need to close fsource to work *)
							Rename(FSource, TTxt);   (* around apparent bug in TP.       *)
							Reset(FSource);

							Assign(FDest, FileN);
							ReWrite(FDest);

							Readln(FSource, LineTemp);

							While (Pos('To: ', LineTemp) = 1) And (AddrCount < MaxAddr) Do
								Begin  (* Copy Internet addresses *)
									Inc(Addrcount);
									InterAddr[AddrCount] := LineTemp;
									Readln(FSource, LineTemp);
								End;   (* Copy Internet addresses *)

							Writeln(FDest, LineTemp);

							While Not EOF(FSource) Do
								Begin  (* Copy the rest of the file *)
									ReadLn(FSource, LineTemp);
									Writeln(FDest, LineTemp);
								End;
							Close(FDest);
							Close(FSource);
							WipeFile(TTxt, Config);
						End;  (* There are Internet Addresses *)
				End;  (* Search for Internet Addresses *)

			Assign(F, FileN);
			ReName(F, Ttxt);

			ComStr := UpCaseStr(Config.SignAndEncrypt);
			N := Pos('@F', ComStr);
			If N > 0 Then
				Begin
					Delete(ComStr, N, 2);
					Insert(Ttxt, ComStr, N);
				End;


			N := Pos('@L', ComStr);
			If N > 0 Then
				Begin
					Delete(ComStr, N, 2);
					Insert(List, ComStr, N);
				End;

			TextColor(DOSFrHi);
			TextBackGround(DOSFrBg);
			MakeBox(DosWinL, DosWinT, DosWinR, DosWinB);
			TextColor(DosFg);
			TextBackGround(DosBg);
			ClrScr;

			SmallCursor;
			Swapvectors;
			Exec(Config.PGPProg, ComStr);
			Swapvectors;
			NoCursor;

			If DosError <> 0 Then
				Begin
					DosTrouble(DosError);
					ReName(F, FileN);
				End
			Else If FileExist(Tasc) Then
				Begin
					Assign(F, Tasc);
					Rename(F, FileN);
					WipeFile(Ttxt, Config);
				End
			Else
				Begin
					Rename(F, FileN);
					PGPError;
					Window(DosWinL + 1, DosWinT + 1, DosWinR - 1, DosWinB - 1);
				End;


			If AddrCount > 0 Then
				Begin  (* Need to add Internet Addresses *)
					Assign(FSource, FileN);
					Rename(FSource, Ttxt);
					Reset(FSource);
					Assign(FDest, FileN);
					ReWrite(FDest);

					For N := 1 to AddrCount Do
						Writeln(FDest, InterAddr[N]);

					Writeln(FDest);
					Writeln(FDest);

					While not EOF(FSource) Do
						Begin
							Readln(FSource, LineTemp);
							Writeln(FDest, LineTemp);
						End;

					Writeln(FDest, Tag);

					Close(FDest);
					Close(FSource);
					Wipefile(Ttxt, Config);
				End  (* Need to add internet Addresses *)
			Else
				Begin (* Need to add tag *)
					Assign(FSource, FileN);
					ReName(Fsource, Ttxt);
					Reset(FSource);
					Assign(FDest, FileN);
					ReWrite(FDest);
					While Not EOF(FSource) Do
						Begin
							Readln(FSource, LineTemp);
							Writeln(FDest, LineTemp);
						End;
					Writeln(FDest, Tag);
					Close(FSource);
					Close(FDest);
					WipeFile(Ttxt, Config);
				End;  (* Need to add tag *)

		End;  (*  SignAndEncrypt defined and no temps around *)
End;   (*  SignAndEncryptMessage  *)

(****************************************************************************)

Procedure SpellCheckMessage(		Config : ConfigType;
																FileN : String);
Var
	N : Byte;
	ComStr : String;

Begin
	If FileExist(Config.SpellProgram) Then
		Begin
			SetIntVec($29, Old_29h);
			TextColor(ExitFg);
			TextBackGround(ExitBg);
			Window(1, 1, 80, 25);
			ClrScr;

			ComStr := UpCaseStr(Config.SpellCommand);
			N := Pos('@F', ComStr);
			If N > 0 Then
				Begin
					Delete(ComStr, N, 2);
					Insert(FileN, ComStr, N);
				End;

			RestoreCursor(Cursor);
			Swapvectors;
			Exec(Config.SpellProgram, ComStr);
			Swapvectors;
			NoCursor;
			SetIntVec($29, @Patch);
			Window(1, 1, 80, 25);
			TextColor(ExitFg);
			TextBackGround(ExitBg);
			ClrScr;

			Window(DosWinL, DosWinT, DosWinR, DosWinB);
			TextColor(DosFg);
			TextBackGround(DosBg);
			ClrScr;
		End
	Else If Config.SpellProgram = '' Then
		Begin
			(*  Do nothing *)
		End
	Else
		Begin
			TextColor(ErrorFrFg);
			TextBackGround(ErrorFrBg);
			MakeBox(17, 7, 63, 18);
			TextColor(ErrorFg);
			TextBackGround(ErrorBg);
			ClrScr;
			WriteCenter(2, 'WARNING');
			WriteAt(Mar, 4, 'EZ-PGP was unable to find your spell-');
			WriteAt(Mar, 5, 'checking program.  Please go to the');
			WriteAt(Mar, 6, '"Change Defaults" menu choice and set');
			WriteAt(Mar, 7, 'up EZ-PGP correctly.');
			WriteCenter(9, 'Please press any key to continue...');
			Repeat Until Keypressed;
			Window(1, 1, 80, 25);
			TextColor(ExitFg);
			TextBackGround(ExitBg);
			ClrScr;
		End;
End;	(*	Spell Check  *)

(****************************************************************************)

Procedure PostAKey(			Config : ConfigType;
										Var ExitNow : Boolean;
												FileN : String);
Var
	N : Byte;
	F1,
	F2 : text;
	LineTemp,
	ComStr,
	KeyID : String;

Begin
	If (Config.PostKey <> '') And TestForTemp Then
		Begin  (* Config.Postkey is not empty *)
			If Config.QuickExit Then
				ExitNow := True;

			TextColor(MenuHigh);
			WriteCenter(7, 'Posting a Key');

			TextColor(MenuFrLo);
			TextBackGround(MenuFrBg);
			MakeBox(MenuWinL, MenuWinT, MenuWinR, MenuWinB);

			Repeat
				TextColor(MenuFrHi);
				TextBackGround(MenuFrBg);
				MakeBox(10, 13, 70, 16);
				TextColor(MenuFg);
				TextBackGround(MenuBg);
				ClrScr;
				WriteCenter(1, 'What Key-ID do you want to post?');
				WriteAt(Mar, 2, 'Key ID:  ');
				SmallCursor;
				ReadLn(KeyID);
				NoCursor;
			Until KeyID <> '';

			TextColor(DOSFrHi);
			TextBackGround(DOSFrBg);
			MakeBox(DosWinL, DosWinT, DosWinR, DosWinB);
			TextColor(DosFg);
			TextBackGround(DosBg);
			ClrScr;

			ComStr := UpCaseStr(Config.PostKey);
			N := Pos('@N', ComStr);
			If N > 0 Then
				Begin
					Delete(ComStr, N, 2);
					Insert(KeyID, ComStr, N);
				End;

			ComStr := ComStr + ' ' + TAsc;

			SmallCursor;
			Swapvectors;
			Exec(Config.PGPProg, ComStr);
			Swapvectors;
			NoCursor;

			If DosError <> 0 Then
				DosTrouble(DosError)
			Else If FileExist(Tasc) Then
				Begin
					(* Add a CRLF pair before the Key starts so it starts *)
					(* on a fresh line.  Otherwise, PGP may not recognize *)
					(* the key.                                           *)
					Assign(F1, FileN);
					Assign(F2, Tasc);
					Append(F1);
					Reset(F2);
					Writeln(F1);
					While not EOF(F2) Do
						Begin
							Readln(F2, LineTemp);
							Writeln(F1, LineTemp);
						End;
					Writeln(F1, Tag);
					Close(F1);
					Close(F2);
					WipeFile(Tasc, Config);
				End
			Else PGPError;
		End;  (*  Config.postkey is not empty *)
End;	(*	Post a Key  *)

(****************************************************************************)

Procedure EditFuncs;
Var
	Config : ConfigType;
	PGPPath : String;
	Ch : Char;
	FileN	:	String;
	ExitNow : Boolean;

Begin  (*  EditFuncs  *)
	ReadConfigFile(Config, PGPPath);
	FileN := ParamStr(2);
	If Not FileExist(FileN) Then  (*  Nofile halts execution--no need  *)
		NoFile(FileN);              (*  for else.                        *)
	ExitNow := False;
	Repeat
		MakeScreen(Config);
		TextColor(MenuFg);
		TextBackGround(MenuBg);
		If ProgramTest(Config, PGPPath) Then
			Begin
				Ch := UpCase(ReadKey);
				Case Ch Of
					'S' :	SignMessage(Config, ExitNow, FileN);
					'E' :	SignAndEncryptMessage(Config, ExitNow, FileN);
					'C'	:	SpellCheckMessage(Config, FileN);
					'P'	:	PostAKey(Config, ExitNow, FileN);
					'D'	:	RunConfig(Config, PGPPath);
				End;  (*  Case Ch  *)
			End  (*  If ProgramTest *)
		Else
			RunConfig(Config, PGPPath);
	Until (Ch = 'Q') or ExitNow;
End;   (*  EditFuncs  *)

(****************************************************************************)

Procedure OnlyConfig;
Var
	Config : ConfigType;
	ConfigPath : String;
Begin
	ReadConfigFile(Config, ConfigPath);
	RunConfig(Config, ConfigPath);
End;


(****************************************************************************)


Begin  (* MAIN  *)
	SaveCursor(Cursor);
	NoCursor;

	Window(1, 1, 80, 25);
	TextColor(ExitFg);
	TextBackGround(ExitBg);
	ClrScr;

	Window(DosWinL, DosWinT, DosWinR, DosWinB);
	TextColor(DosFg);
	TextBackGround(DosBg);
	ClrScr;

	Window(1, 1, 80, 25);

	GetINtVec($29, OLD_29H);
	SetIntVec($29, @Patch);

	If UpCaseStr(ParamStr(1)) = 'C' Then
		OnlyConfig
	Else If UpCaseStr(ParamStr(1)) = 'E' Then
		EditFuncs
	Else
		ShowHelp;

	SetIntVec($29, OLD_29h);
	Window(1, 1, 80, 25);
	TextColor(ExitFg);
	TextBackGround(ExitBg);
	ClrScr;
	RestoreCursor(Cursor);
End.  (*  MAIN  *)