{

This MISC unit is copyright 1994, 1995, 1996 by John Schofield.  This source
code may be freely modified and distributed as long as:

		1)  Credit is given to John Schofield
		2)  No money is charged for the program

In other words, feel free to use this, but don't steal it from me, and do NOT
charge money for any product you make using my source code.

I move frequently, and methods of contacting me don't stay good very long.
However, I'm making an effort to keep two of them good no matter what.

You can always e-mail me at ac086@lafn.org.

You can always write me at:

							John Schofield
							P.O. Box 571312
							Tarzana, CA 91357-1312


}





Unit MISC;

Interface

Uses
	DOS;

Type
	CursorType = Record
		StartLine,
		EndLine    : Byte;
	End;

Function UpCaseStr(S : String) : String;
Function FileExist(FileN : String) : Boolean;
Function DirExist(DirN : DirStr) : Boolean;
Procedure WriteCenter(Y : Integer; S : String);
Procedure WriteAt(X, Y : Integer; S : String);
Procedure MakeBox(Left, Top, Right, Bottom : Integer);
Procedure SaveCursor(Var C : CursorType);
Procedure RestoreCursor(C : CursorType);
Procedure NoCursor;
Procedure SmallCursor;
Procedure BigCursor;

Implementation

Uses
	CRT;


Function UpCaseStr(S : String) : String;
Var
	N : Byte;
Begin
	For N := 1 to Length(S) Do
		S[N] := UpCase(S[N]);
	UpCaseStr := S;
End;


Function DirExist(DirN : DirStr) : Boolean;
Var
	F	:	file;
	Attr	:	word;

begin
	Assign(F, DirN);
	GetFAttr(F, Attr);

	If (DosError = 0) And (Attr And Directory <> 0) Then
		DirExist := True
	Else
		DirExist := False;
	DosError := 0;
end;



Function FileExist(FileN : String) : Boolean;
Var
	F : File;
Begin
	{$I-}
	Assign(F, FileN);
	Reset(F);
	Close(F);
	{$I+}
	FileExist := (IOResult = 0) And (FileN <> '');
End;


Procedure WriteCenter(Y : Integer; S : String);
Var
	Space,
	L,
	R : Integer;
Begin
	L := Lo(WindMin);
	R := Lo(WindMax);

	GoToXY(1, Y);
	ClrEOL;

	Space := Round((R - L) / 2);

	Write( S:Space + (Length(S) Div 2) );

End;

Procedure WriteAt(X, Y : Integer; S : String);
Begin
	GoToXY(X, Y);
	Write(S);
End;



(*  Just makes a box, does not clear the screen.  You may just want to *)
(*  redraw a box without changing the contents. *)

Procedure MakeBox(Left, Top, Right, Bottom : Integer);
Var
	X,
	Y	: Byte;
Begin  (*  MakeBox  *)
	Window(1, 1, 80, 25);

	For Y := Top + 1 to Bottom - 1 Do  (* Write Vertical lines *)
		Begin
			X := Right;
			WriteAt(X, Y, '');     (*  Right Line *)
			X := Left;
			WriteAt(X, Y, '');    (*  Left Line  *)
		End;

	For X := Left + 1 to Right - 1 Do (* Write Horizontal Lines *)
		Begin
			Y := Top;
			WriteAt(X, Y, '');    (*  Top Line  *)
			Y := Bottom;
			WriteAt(X, Y, '');    (*  Bottom Line  *)
		End;

	WriteAt(Left, Top, '');  (*  Top Left  *)
	WriteAt(Right, Top, '');  (*  Top Right  *)
	WriteAt(Left, Bottom, '');  (*  Bottom Left  *)
	WriteAt(Right, Bottom, '');   (*  Bottom Right corner  *)
	Window(Left + 1, Top + 1, Right - 1, Bottom - 1);
End;  (*  MakeBox  *)


Procedure SaveCursor(Var C : CursorType);
Var
	Regs : Registers;
Begin
	FillChar(Regs, SizeOf(Regs), 0);
	Regs.AH := $03;  (*  Function number *)
	Regs.BH := $00;  (*  Video Page Number *)
	Intr($10, Regs);
	C.StartLine := Regs.CH;
	C.EndLine := Regs.CL;
End;


Procedure RestoreCursor(C : CursorType);
Var
	Regs : Registers;
Begin
	FillChar(Regs, SizeOf(Regs), 0);
	Regs.AH := $01;
	Regs.CH := C.StartLine;
	Regs.CL := C.EndLine;
	Intr($10, Regs);
End;


Procedure NoCursor;
Var
	Regs : Registers;
Begin
	FillChar(Regs, SizeOf(Regs), 0);
	Regs.AH := $01;   (*  Select Function  *)
	Regs.CH := $20;   (*  Disable Cursor   *)
	Intr($10, Regs);
End;


Procedure SmallCursor;
Var
	Regs : Registers;
Begin
	FillChar(Regs, SizeOf(Regs), 0);
	Regs.AH := $01;
	Regs.CH := $06;
	Regs.CL := $07;
	Intr($10, Regs);
End;

Procedure BigCursor;
Var
	Regs : Registers;
Begin
	FillChar(Regs, SizeOf(Regs), 0);
	Regs.AH := $01;
	Regs.CH := $00;
	Regs.CL := $07;
	Intr($10, Regs);
End;


End.